<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 417 $
 * $Id: About.php 417 2006-12-06 22:58:53Z ipso $
 * $Date: 2006-12-06 14:58:53 -0800 (Wed, 06 Dec 2006) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

//Debug::setVerbosity( 11 );

$title = 'About';
$smarty->assign('title', $title);
BreadCrumb::setCrumb($title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												) ) );

$data = $system_settings;

if ( isProfessionalEditionAvailable() == TRUE ) {
	$data['product_edition'] = 'Professional';
} else {
	$data['product_edition'] = 'Standard';
}

//$sslf = new SystemSettingListFactory();
//$data = $sslf->getAllArray();
/*
$sslf->getByName('system_version');
if ( $sslf->getRecordCount() == 1 ) {
	$data['system_version'] = $sslf->getCurrent()->getValue();
}

$sslf->getByName('tax_engine_version');
if ( $sslf->getRecordCount() == 1 ) {
	$data['tax_engine_version'] = $sslf->getCurrent()->getValue();
}

$sslf->getByName('tax_data_version');
if ( $sslf->getRecordCount() == 1 ) {
	$data['tax_data_version'] = $sslf->getCurrent()->getValue();
}

$sslf->getByName('schema_version_group_A');
if ( $sslf->getRecordCount() == 1 ) {
	$data['schema_version']['A'] = $sslf->getCurrent()->getValue();
}
$sslf->getByName('schema_version_group_B');
if ( $sslf->getRecordCount() == 1 ) {
	$data['schema_version']['B'] = $sslf->getCurrent()->getValue();
}
$sslf->getByName('schema_version_group_T');
if ( $sslf->getRecordCount() == 1 ) {
	$data['schema_version']['T'] = $sslf->getCurrent()->getValue();
}
*/

//Get Employee counts for this month, and last month

$month_of_year_arr = TTDate::getMonthOfYearArray();

//This month
$begin_month_epoch = TTDate::getBeginMonthEpoch();

$cuclf = new CompanyUserCountListFactory();
$cuclf->getMinAvgMaxByCompanyIdAndStartDateAndEndDate( $current_company->getId(), $begin_month_epoch, TTDate::getEndMonthEpoch($begin_month_epoch) );
if ( $cuclf->getRecordCount() > 0 ) {
	$cuc_obj = $cuclf->getCurrent();

	$data['user_counts']['this_month'] = array(
													'label' => $month_of_year_arr[TTDate::getMonth( $begin_month_epoch )] .' '. TTDate::getYear($begin_month_epoch),
													'max_active_users' => $cuc_obj->getColumn('max_active_users'),
													'max_inactive_users' => $cuc_obj->getColumn('max_inactive_users'),
													'max_deleted_users' => $cuc_obj->getColumn('max_deleted_users'),
													);
}

//Last month
$begin_last_month_epoch = TTDate::getBeginMonthEpoch($begin_month_epoch-86400);

$cuclf = new CompanyUserCountListFactory();
$cuclf->getMinAvgMaxByCompanyIdAndStartDateAndEndDate( $current_company->getId(), $begin_last_month_epoch, TTDate::getEndMonthEpoch($begin_last_month_epoch) );
if ( $cuclf->getRecordCount() > 0 ) {
	$cuc_obj = $cuclf->getCurrent();

	$data['user_counts']['last_month'] = array(
													'label' => $month_of_year_arr[TTDate::getMonth( $begin_last_month_epoch )] .' '. TTDate::getYear($begin_last_month_epoch),
													'max_active_users' => $cuc_obj->getColumn('max_active_users'),
													'max_inactive_users' => $cuc_obj->getColumn('max_inactive_users'),
													'max_deleted_users' => $cuc_obj->getColumn('max_deleted_users'),
													);

}

//var_dump($data);
$smarty->assign_by_ref('data', $data);

$smarty->display('help/About.tpl');
?>