<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 499 $
 * $Id: Form941.php 499 2007-01-05 17:05:02Z ipso $
 * $Date: 2007-01-05 09:05:02 -0800 (Fri, 05 Jan 2007) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');
require(Environment::getBasePath() .'/classes/fpdf/fpdf.php');
require(Environment::getBasePath() .'/classes/fpdi/fpdi.php');

if ( !$permission->Check('report','enabled')
		OR !$permission->Check('report','view_form941') ) {
	$permission->Redirect( FALSE ); //Redirect
}

$title = 'Form 941 Report';
$smarty->assign('title', $title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'setup_data',
												'generic_data',
												'filter_data'
												) ) );

URLBuilder::setURL($_SERVER['SCRIPT_NAME'],
											array(
													'filter_data' => $filter_data
//													'sort_column' => $sort_column,
//													'sort_order' => $sort_order,
												) );

$pseallf = new PayStubEntryAccountLinkListFactory();
$pseallf->getByCompanyId( $current_company->getId() );
if ( $pseallf->getRecordCount() > 0 ) {
	$pseal_obj = $pseallf->getCurrent();
}

$column_ps_entry_name_map = array(
								'2' => @$setup_data['2_psea_ids'], //Gross Pay
								'3' => @$setup_data['3_psea_ids'],
								'5a' => @$setup_data['5a_psea_ids'],
								'5b' => @$setup_data['5b_psea_ids'],
								'5c' => @$setup_data['5c_psea_ids'],
								'9' => @$setup_data['9_psea_ids'],
								);

$pplf = new PayPeriodListFactory();
$year_options = $pplf->getYearsArrayByCompanyId( $current_company->getId() );

$quarter_options = array(
						1 => 'Quarter 1 (01-Jan to 31-Mar)',
						2 => 'Quarter 2 (01-Apr to 30-Jun)',
						3 => 'Quarter 3 (01-Jul to 30-Sep)',
						4 => 'Quarter 4 (01-Oct to 31-Dec)',
						);

$quarter_dates = array(
						1 => array(
									1 => array( 'start' => mktime(0,0,0,1,1, $filter_data['year'] ), 'end' => mktime(0,0,0,2,0, $filter_data['year'] ) ),
									2 => array( 'start' => mktime(0,0,0,2,1, $filter_data['year'] ), 'end' => mktime(0,0,0,3,0, $filter_data['year'] ) ),
									3 => array( 'start' => mktime(0,0,0,3,1, $filter_data['year'] ), 'end' => mktime(0,0,0,4,0, $filter_data['year'] ) ),
									),
						2 => array(
									1 => array( 'start' => mktime(0,0,0,4,1, $filter_data['year'] ), 'end' => mktime(0,0,0,5,0, $filter_data['year'] ) ),
									2 => array( 'start' => mktime(0,0,0,5,1, $filter_data['year'] ), 'end' => mktime(0,0,0,6,0, $filter_data['year'] ) ),
									3 => array( 'start' => mktime(0,0,0,6,1, $filter_data['year'] ), 'end' => mktime(0,0,0,7,0, $filter_data['year'] ) ),
									),
						3 => array(
									1 => array( 'start' => mktime(0,0,0,7,1, $filter_data['year'] ), 'end' => mktime(0,0,0,8,0, $filter_data['year'] ) ),
									2 => array( 'start' => mktime(0,0,0,8,1, $filter_data['year'] ), 'end' => mktime(0,0,0,9,0, $filter_data['year'] ) ),
									3 => array( 'start' => mktime(0,0,0,9,1, $filter_data['year'] ), 'end' => mktime(0,0,0,10,0, $filter_data['year'] ) ),
									),
						4 => array(
									1 => array( 'start' => mktime(0,0,0,10,1, $filter_data['year'] ), 'end' => mktime(0,0,0,11,0, $filter_data['year'] ) ),
									2 => array( 'start' => mktime(0,0,0,11,1, $filter_data['year'] ), 'end' => mktime(0,0,0,12,0, $filter_data['year'] ) ),
									3 => array( 'start' => mktime(0,0,0,12,1, $filter_data['year'] ), 'end' => mktime(0,0,0,13,0, $filter_data['year'] ) ),
									)
						);

if ( !isset($filter_data['include_user_ids']) ) {
	$filter_data['include_user_ids'] = array();
}
if ( !isset($filter_data['exclude_user_ids']) ) {
	$filter_data['exclude_user_ids'] = array();
}
if ( !isset($filter_data['user_status_ids']) ) {
	$filter_data['user_status_ids'] = array();
}
if ( !isset($filter_data['group_ids']) ) {
	$filter_data['group_ids'] = array();
}
if ( !isset($filter_data['branch_ids']) ) {
	$filter_data['branch_ids'] = array();
}
if ( !isset($filter_data['department_ids']) ) {
	$filter_data['department_ids'] = array();
}
if ( !isset($filter_data['user_title_ids']) ) {
	$filter_data['user_title_ids'] = array();
}

$ugdlf = new UserGenericDataListFactory();
$ugdf = new UserGenericDataFactory();

$action = strtolower($action);
Debug::Text('Action: '. $action, __FILE__, __LINE__, __METHOD__,10);
switch ($action) {
	case 'display form':
	case 'display report':
		//Debug::setVerbosity(11);

		Debug::Text('Submit!: '. $action, __FILE__, __LINE__, __METHOD__,10);
		Debug::Arr($filter_data, 'aFilter Data', __FILE__, __LINE__, __METHOD__,10);

		//Save report setup data
		$ugdlf->getByCompanyIdAndScriptAndDefault( $current_company->getId(), $_SERVER['SCRIPT_NAME'] );
		if ( $ugdlf->getRecordCount() > 0 ) {
			$ugdf->setID( $ugdlf->getCurrent()->getID() );
		}
		$ugdf->setCompany( $current_company->getId() );
		$ugdf->setName( $title );
		$ugdf->setScript( $_SERVER['SCRIPT_NAME'] );
		$ugdf->setData( $setup_data );
		$ugdf->setDefault( TRUE );
		if ( $ugdf->isValid() ) {
			$ugdf->Save();
		}

		$ulf = new UserListFactory();
		$ulf->getSearchByCompanyIdAndArrayCriteria( $current_company->getId(), $filter_data );

		if ( $ulf->getRecordCount() > 0 ) {
			foreach( $ulf as $u_obj ) {
				$filter_data['user_ids'][] = $u_obj->getId();
			}

			if ( isset($filter_data['user_ids']) AND isset($filter_data['quarter_id']) ) {
				$pseallf = new PayStubEntryAccountLinkListFactory();
				$pseallf->getByCompanyId( $current_company->getId() );
				if ( $pseallf->getRecordCount() > 0 ) {
					$pseal_obj = $pseallf->getCurrent();
				}

				//
				//Get all data for the form.
				//
				$ein = str_replace(array('-', ' '), '', $current_company->getBusinessNumber() );

				$total_users = 0;
				foreach( $quarter_dates[$filter_data['quarter_id']] as $month_id => $quarter_dates_arr ) {
					//Get Pay Periods in date range.
					Debug::Text('Start Date: '. TTDate::getDate('DATE+TIME', $quarter_dates_arr['start']) .' End Date: '. TTDate::getDate('DATE+TIME', $quarter_dates_arr['end']), __FILE__, __LINE__, __METHOD__,10);
					$pplf = new PayPeriodListFactory();
					$pplf->getByCompanyIdAndTransactionStartDateAndTrasnactionEndDate( $current_company->getId(), $quarter_dates_arr['start'], $quarter_dates_arr['end'] );
					if ( $pplf->getRecordCount() > 0 ) {
						foreach($pplf as $pp_obj) {
							$pay_period_ids[] = $pp_obj->getID();
						}
					}

					if ( isset($pay_period_ids) ) {
						$pslf = new PayStubListFactory();
						$pslf->getByCompanyIdAndPayPeriodId( $current_company->getId(), $pay_period_ids );
						if ( $pslf->getRecordCount() > 0 ) {
							foreach( $pslf as $ps_obj ) {
								if ( in_array( $ps_obj->getUser(), $filter_data['user_ids']) ) {
									$pay_stub_users[] = $ps_obj->getUser();
								}
							}
							$pay_stub_users = array_unique($pay_stub_users);
						}
						if ( count($pay_stub_users) > $total_users ) {
							$total_users = count($pay_stub_users);
						}
						unset($pay_stub_users);

						//PS Account Amounts...
						//Get employees who have recieved pay stubs.
						$pself = new PayStubEntryListFactory();
						$pself->getReportByCompanyIdAndUserIdAndPayPeriodId( $current_company->getId(), $filter_data['user_ids'], $pay_period_ids );
						if ( $pself->getRecordCount() > 0 ) {
							foreach( $pself as $pse_obj ) {
								//$user_id = $pse_obj->getColumn('user_id');
								//$pay_stub_entry_name_id = $pse_obj->getColumn('pay_stub_entry_name_id');
								$pay_stub_entry_name_id = $pse_obj->getPayStubEntryNameId();

								if ( isset($ps_entries[$pay_stub_entry_name_id]) ) {
									$ps_entries[$pay_stub_entry_name_id] = bcadd($ps_entries[$pay_stub_entry_name_id],$pse_obj->getColumn('amount'),2 );
								} else {
									$ps_entries[$pay_stub_entry_name_id] = $pse_obj->getColumn('amount');
								}
							}
						}

						$lines_arr[$month_id]['2'] = Misc::sumMultipleColumns( $ps_entries, $column_ps_entry_name_map['2']);
						$lines_arr[$month_id]['3'] = Misc::sumMultipleColumns( $ps_entries, $column_ps_entry_name_map['3']);

						$lines_arr[$month_id]['5a'] = Misc::sumMultipleColumns( $ps_entries, $column_ps_entry_name_map['5a']);
						$lines_arr[$month_id]['5a2'] = bcmul( $lines_arr[$month_id]['5a'], 0.124 );
						$lines_arr[$month_id]['5b'] = Misc::sumMultipleColumns( $ps_entries, $column_ps_entry_name_map['5b']);
						$lines_arr[$month_id]['5b2'] = bcmul( $lines_arr[$month_id]['5b'], 0.124 );
						$lines_arr[$month_id]['5c'] = Misc::sumMultipleColumns( $ps_entries, $column_ps_entry_name_map['5c']);
						$lines_arr[$month_id]['5c2'] = bcmul( $lines_arr[$month_id]['5c'], 0.129 );
						$lines_arr[$month_id]['5d'] =  bcadd( bcadd( $lines_arr[$month_id]['5a2'], $lines_arr[$month_id]['5b2']), $lines_arr[$month_id]['5c2']);
						$lines_arr[$month_id]['6'] = bcadd( $lines_arr[$month_id]['3'], $lines_arr[$month_id]['5d']);

						$lines_arr[$month_id]['7a'] = bcsub( Misc::MoneyFormat($lines_arr[$month_id]['5d'], FALSE) , bcadd( bcadd($lines_arr[$month_id]['5a2'], $lines_arr[$month_id]['5b2']), $lines_arr[$month_id]['5c2'] ) );

						$lines_arr[$month_id]['7h'] = $lines_arr[$month_id]['7a'];
						$lines_arr[$month_id]['8'] = bcadd( $lines_arr[$month_id]['6'], $lines_arr[$month_id]['7h']);
						$lines_arr[$month_id]['9'] = Misc::sumMultipleColumns( $ps_entries, $column_ps_entry_name_map['9']);
						$lines_arr[$month_id]['10'] = bcsub( $lines_arr[$month_id]['8'], $lines_arr[$month_id]['9']);
						$lines_arr[$month_id]['11'] = 0;
						$lines_arr[$month_id]['12'] = Misc::MoneyFormat( abs( bcsub( $lines_arr[$month_id]['11'],$lines_arr[$month_id]['10']) ), FALSE );
					}
					unset($pay_period_ids, $ps_entries);
				}
				if ( isset($lines_arr) ) {
					$lines_arr['total'] = Misc::ArrayAssocSum($lines_arr, NULL, 6);
					Debug::Arr($lines_arr, 'Lines Array: ', __FILE__, __LINE__, __METHOD__,10);
				}

				$border = 0;

				$pdf= new fpdi();

				//Import original Gov't supplied PDF.
				$pagecount = $pdf->setSourceFile(Environment::getBasePath().'interface'. DIRECTORY_SEPARATOR .'forms'. DIRECTORY_SEPARATOR .'us'. DIRECTORY_SEPARATOR .'tax'. DIRECTORY_SEPARATOR .'f941.pdf');
				$tplidx = $pdf->ImportPage(1);
				$tplidx2 = $pdf->ImportPage(2);

				$pdf->setMargins(0,0,0,0);
				$pdf->SetAutoPageBreak(FALSE);
				$pdf->SetFont('Arial','',10);

				$pdf->AddPage();
				$pdf->useTemplate($tplidx,0,0);

				//EIN
				$pdf->setXY(54,25);
				$pdf->Cell(7,7,$ein[0], $border, 0, 'C');

				$pdf->setXY(63,25);
				$pdf->Cell(7,7,$ein[1], $border, 0, 'C');

				$pdf->setXY(77,25);
				$pdf->Cell(7,7,$ein[2], $border, 0, 'C');

				$pdf->setXY(85,25);
				$pdf->Cell(7,7,$ein[3], $border, 0, 'C');

				$pdf->setXY(94,25);
				$pdf->Cell(7,7,$ein[4], $border, 0, 'C');

				$pdf->setXY(103,25);
				$pdf->Cell(7,7,$ein[5], $border, 0, 'C');

				$pdf->setXY(111,25);
				$pdf->Cell(7,7,$ein[6], $border, 0, 'C');

				$pdf->setXY(121,25);
				$pdf->Cell(7,7,$ein[7], $border, 0, 'C');

				$pdf->setXY(130,25);
				$pdf->Cell(7,7,$ein[8], $border, 0, 'C');

				$pdf->setXY(48,34);
				$pdf->Cell(90,6,$current_company->getName(), $border, 0, 'L');

				$pdf->setXY(28,51);
				$pdf->Cell(100,6,$current_company->getAddress1() .' '. $current_company->getAddress2(), $border, 0, 'L');

				$pdf->setXY(28,59);
				$pdf->Cell(65,6,$current_company->getCity(), $border, 0, 'L');

				$pdf->setXY(96,59);
				$pdf->Cell(12,6,$current_company->getProvince(), $border, 0, 'C');

				$pdf->setXY(111,59);
				$pdf->Cell(23,6,$current_company->getPostalCode(), $border, 0, 'C');

				//Select Quarter
				switch( $filter_data['quarter_id'] ) {
					case 1;
						$pdf->setXY(149,37);
						break;
					case 2;
						$pdf->setXY(149,43);
						break;
					case 3;
						$pdf->setXY(149,50);
						break;
					case 4;
						$pdf->setXY(149,56);
						break;

				}
				$pdf->Cell(5,6,'X', $border, 0, 'C');

				//Line1
				$pdf->setXY(173,81);
				$pdf->Cell(25,6,$total_users, $border, 0, 'R');

				if ( isset($lines_arr) ) {
					//Line2
					$pdf->setXY(165,88);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['2'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(193,88);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['2'], FALSE) ), $border, 0, 'L');

					//Line3
					$pdf->setXY(165,96);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['3'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(193,96);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['3'], FALSE) ), $border, 0, 'L');

					if ( $lines_arr['total']['5d'] == 0 ) {
						$pdf->setXY(155,102);
						$pdf->Cell(5,6, 'X', $border, 0, 'L');
					}

					//Line5a - 1
					$pdf->setXY(70,116);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['5a'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(97,116);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['5a'], FALSE) ), $border, 0, 'L');
					//Line5a - 2
					$pdf->setXY(121,116);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['5a2'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(148,116);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['5a2'], FALSE) ), $border, 0, 'L');

					//Line5b - 1
					$pdf->setXY(70,123);
					$pdf->Cell(25,6, Misc::getBeforeDecimal(Misc::MoneyFormat($lines_arr['total']['5b'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(97,123);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['5b'], FALSE) ), $border, 0, 'L');
					//Line5b - 2
					$pdf->setXY(121,123);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['5b2'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(148,123);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['5b2'], FALSE) ), $border, 0, 'L');

					//Line5c - 1
					$pdf->setXY(70,131);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['5c'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(97,131);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['5c'], FALSE) ), $border, 0, 'L');
					//Line5c - 2
					$pdf->setXY(121,131);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['5c2'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(148,131);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['5c2'], FALSE) ), $border, 0, 'L');

					//Line5d
					$pdf->setXY(165,139);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['5d'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(193,139);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['5d'], FALSE) ), $border, 0, 'L');

					//Line6
					$pdf->setXY(165,146);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['6'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(193,146);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['6'], FALSE) ), $border, 0, 'L');

					//Line7a
					$pdf->setXY(121,157);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['7a'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(148,157);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['7a'], FALSE) ), $border, 0, 'L');

					//Line7h
					$pdf->setXY(165,209);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['7h'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(193,209);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['7h'], FALSE) ), $border, 0, 'L');

					//Line8
					$pdf->setXY(165,216);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['8'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(193,216);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['8'], FALSE) ), $border, 0, 'L');

					//Line9
					$pdf->setXY(165,223);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['9'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(193,223);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['9'], FALSE) ), $border, 0, 'L');

					//Line10
					$pdf->setXY(165,231);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['10'], FALSE) ), $border, 0, 'R');
					$pdf->setXY(193,231);
					$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['10'], FALSE) ), $border, 0, 'L');

					//Line11
					$pdf->setXY(165,238);
					$pdf->Cell(25,6, Misc::getBeforeDecimal( 0 ), $border, 0, 'R');
					$pdf->setXY(193,238);
					$pdf->Cell(6,6, Misc::getAfterDecimal( '0.00' ), $border, 0, 'L');

					//Line12
					if ( isset($lines_arr['total']['12']) ) {
						$pdf->setXY(165,246);
						$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['12'], FALSE) ), $border, 0, 'R');
						$pdf->setXY(193,246);
						$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['12'], FALSE) ), $border, 0, 'L');
					}

					//Line13
					/*
					if ( isset($line13) ) {
						$pdf->setXY(121,255);
						$pdf->Cell(25,6, Misc::getBeforeDecimal( $line13 ), $border, 0, 'R');
						$pdf->setXY(148,255);
						$pdf->Cell(6,6, Misc::getAfterDecimal( $line13 ), $border, 0, 'L');
					}
					*/


					$pdf->AddPage();
					$pdf->useTemplate($tplidx2,0,0);

					//Company
					$pdf->setXY(14,24);
					$pdf->Cell(90,6,$current_company->getName(), $border, 0, 'L');

					//EIN
					$pdf->setXY(141,24);
					$pdf->Cell(50,6,$current_company->getBusinessNumber(), $border, 0, 'L');

					//Deposit State
					$pdf->setXY(23,44);
					$pdf->Cell(5,6, substr($current_company->getProvince(),0,1), $border, 0, 'L');
					$pdf->setXY(31,44);
					$pdf->Cell(5,6, substr($current_company->getProvince(),1,1), $border, 0, 'L');

					//Line15
					if ( $lines_arr['total']['10'] < 2500 ) {
						$pdf->setXY(40,55);
						$pdf->Cell(5,6, 'X', $border, 0, 'L');
					} else {
						$pdf->setXY(40,61);
						$pdf->Cell(5,6, 'X', $border, 0, 'L');

						//Split taxes out by month
						$pdf->setXY(93,72);
						$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['1']['10'], FALSE) ), $border, 0, 'R');
						$pdf->setXY(121,72);
						$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['1']['10'], FALSE) ), $border, 0, 'L');

						$pdf->setXY(93,80);
						$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['2']['10'], FALSE) ), $border, 0, 'R');
						$pdf->setXY(121,80);
						$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['2']['10'], FALSE) ), $border, 0, 'L');

						$pdf->setXY(93,89);
						$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['3']['10'], FALSE) ), $border, 0, 'R');
						$pdf->setXY(121,89);
						$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['3']['10'], FALSE) ), $border, 0, 'L');

						$pdf->setXY(93,98);
						$pdf->Cell(25,6, Misc::getBeforeDecimal( Misc::MoneyFormat($lines_arr['total']['10'], FALSE) ), $border, 0, 'R');
						$pdf->setXY(121,98);
						$pdf->Cell(6,6, Misc::getAfterDecimal( Misc::MoneyFormat($lines_arr['total']['10'], FALSE) ), $border, 0, 'L');
					}
				}
				//Finish off PDF
				//$pdf->Output();
				$output = $pdf->Output('','S');
				$pdf->closeParsers();

				//Debug::Display();
				Misc::FileDownloadHeader('f941.pdf', 'application/pdf', strlen($output));
				echo $output;
				exit;
			}
		}
		break;
	case 'delete':
	case 'save':
		Debug::Text('Action: '. $action, __FILE__, __LINE__, __METHOD__,10);

		$generic_data['id'] = UserGenericDataFactory::reportFormDataHandler( $action, $filter_data, $generic_data, URLBuilder::getURL(NULL, $_SERVER['SCRIPT_NAME']) );
		unset($generic_data['name']);
	default:
		BreadCrumb::setCrumb($title);

		$ugdlf->getByCompanyIdAndScriptAndDefault( $current_company->getId(), $_SERVER['SCRIPT_NAME'] );
		if ( $ugdlf->getRecordCount() > 0 ) {
			Debug::Text('Found Company Report Setup!', __FILE__, __LINE__, __METHOD__,10);
			$ugd_obj = $ugdlf->getCurrent();
			$setup_data = $ugd_obj->getData();
		}
		unset($ugd_obj);

		if ( $action == 'load' ) {
			Debug::Text('Loading Report!', __FILE__, __LINE__, __METHOD__,10);
			extract( UserGenericDataFactory::getReportFormData( $generic_data['id'] ) );
		} elseif ( $action == '' ) {
			//Check for default saved report first.
			$ugdlf->getByUserIdAndScriptAndDefault( $current_user->getId(), $_SERVER['SCRIPT_NAME'] );
			if ( $ugdlf->getRecordCount() > 0 ) {
				Debug::Text('Found Default Report!', __FILE__, __LINE__, __METHOD__,10);

				$ugd_obj = $ugdlf->getCurrent();
				$filter_data = $ugd_obj->getData();
				$generic_data['id'] = $ugd_obj->getId();
			} else {
				Debug::Text('Default Settings!', __FILE__, __LINE__, __METHOD__,10);
				//Default selections
				$filter_data['user_status_ids'] = array( -1 );
				$filter_data['branch_ids'] = array( -1 );
				$filter_data['department_ids'] = array( -1 );
				$filter_data['user_title_ids'] = array( -1 );
				$filter_data['group_ids'] = array( -1 );
			}
		}

		$ulf = new UserListFactory();
		$all_array_option = array('-1' => '-- All --');

		//Get include employee list.
		$ulf->getByCompanyId( $current_company->getId() );
		$user_options = $ulf->getArrayByListFactory( $ulf, FALSE, TRUE );

		$filter_data['src_include_user_options'] = Misc::arrayDiffByKey( (array)$filter_data['include_user_ids'], $user_options );
		$filter_data['selected_include_user_options'] = Misc::arrayIntersectByKey( (array)$filter_data['include_user_ids'], $user_options );

		//Get exclude employee list
		$exclude_user_options = Misc::prependArray( $all_array_option, $ulf->getArrayByListFactory( $ulf, FALSE, TRUE ) );
		$filter_data['src_exclude_user_options'] = Misc::arrayDiffByKey( (array)$filter_data['exclude_user_ids'], $user_options );
		$filter_data['selected_exclude_user_options'] = Misc::arrayIntersectByKey( (array)$filter_data['exclude_user_ids'], $user_options );

		//Get employee status list.
		$user_status_options = Misc::prependArray( $all_array_option, $ulf->getOptions('status') );
		$filter_data['src_user_status_options'] = Misc::arrayDiffByKey( (array)$filter_data['user_status_ids'], $user_status_options );
		$filter_data['selected_user_status_options'] = Misc::arrayIntersectByKey( (array)$filter_data['user_status_ids'], $user_status_options );

		//Get Employee Groups
		$uglf = new UserGroupListFactory();
		$group_options = Misc::prependArray( $all_array_option, $uglf->getArrayByNodes( FastTree::FormatArray( $uglf->getByCompanyIdArray( $current_company->getId() ), 'TEXT', TRUE) ) );
		$filter_data['src_group_options'] = Misc::arrayDiffByKey( (array)$filter_data['group_ids'], $group_options );
		$filter_data['selected_group_options'] = Misc::arrayIntersectByKey( (array)$filter_data['group_ids'], $group_options );

		//Get branches
		$blf = new BranchListFactory();
		$blf->getByCompanyId( $current_company->getId() );
		$branch_options = Misc::prependArray( $all_array_option, $blf->getArrayByListFactory( $blf, FALSE, TRUE ) );
		$filter_data['src_branch_options'] = Misc::arrayDiffByKey( (array)$filter_data['branch_ids'], $branch_options );
		$filter_data['selected_branch_options'] = Misc::arrayIntersectByKey( (array)$filter_data['branch_ids'], $branch_options );

		//Get departments
		$dlf = new DepartmentListFactory();
		$dlf->getByCompanyId( $current_company->getId() );
		$department_options = Misc::prependArray( $all_array_option, $dlf->getArrayByListFactory( $dlf, FALSE, TRUE ) );
		$filter_data['src_department_options'] = Misc::arrayDiffByKey( (array)$filter_data['department_ids'], $department_options );
		$filter_data['selected_department_options'] = Misc::arrayIntersectByKey( (array)$filter_data['department_ids'], $department_options );

		//Get employee titles
		$utlf = new UserTitleListFactory();
		$utlf->getByCompanyId( $current_company->getId() );
		$user_title_options = Misc::prependArray( $all_array_option, $utlf->getArrayByListFactory( $utlf, FALSE, TRUE ) );
		$filter_data['src_user_title_options'] = Misc::arrayDiffByKey( (array)$filter_data['user_title_ids'], $user_title_options );
		$filter_data['selected_user_title_options'] = Misc::arrayIntersectByKey( (array)$filter_data['user_title_ids'], $user_title_options );

		//Deduction PSEA accounts
		$psealf = new PayStubEntryAccountListFactory();
		$filter_data['deduction_pay_stub_entry_account_options'] = $psealf->getByCompanyIdAndStatusIdAndTypeIdArray( $current_company->getId(), 10, array(20,30), TRUE );
		$filter_data['earning_pay_stub_entry_account_options'] = $psealf->getByCompanyIdAndStatusIdAndTypeIdArray( $current_company->getId(), 10, array(10,40), TRUE );
		$filter_data['income_pay_stub_entry_account_options'] = $psealf->getByCompanyIdAndStatusIdAndTypeIdArray( $current_company->getId(), 10, array(10,30,40), TRUE );

		//Get employee list
		//$filter_data['user_options'] = UserListFactory::getByCompanyIdArray( $current_company->getId(), FALSE );

		//Quarters
		$filter_data['quarter_options'] = $quarter_options;
		$filter_data['year_options'] = $year_options;

		$saved_report_options = $ugdlf->getByUserIdAndScriptArray( $current_user->getId(), $_SERVER['SCRIPT_NAME']);
		$generic_data['saved_report_options'] = $saved_report_options;
		$smarty->assign_by_ref('generic_data', $generic_data);

		$smarty->assign_by_ref('filter_data', $filter_data);
		$smarty->assign_by_ref('setup_data', $setup_data);

		$smarty->assign_by_ref('ugdf', $ugdf);

		$smarty->display('report/Form941.tpl');

		break;
}
?>